/* $Id: symbol.c,v 1.1 1996/11/07 08:04:02 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	V{l[ǗW[
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyleft 1997 Tachibana Eriko.
 *
 */

#include	<stdio.h>
#include	<string.h>
#include	"estruct.h"
#include	"global.h"
#include	"etc.h"
#include	"symbol.h"
#include	"label.h"


int		Symbolbufsize;		/* V{obt@̐ */
static symbol	*Symtable = NULL;	/* V{e[u̓ */
static int	Symnum;			/* V{e[u̗vf */

static const_symbol *ConstSymtable = NULL;	/* V{e[u̓ */
static int	    ConstSymnum;		/* V{e[u̗vf */


extern void	init_symtable()
{
    if( (( Symtable  = (symbol *)Malloc( Symbolbufsize * sizeof( symbol ) ) ) == NULL) ||
	(( ConstSymtable = (const_symbol *)Malloc( Symbolbufsize * sizeof( const_symbol ) ) ) == NULL ) )
	err( 1 , "V{e[uobt@mۏo܂ł\n" );

    Symnum = 0;
    ConstSymnum = 0;
}


/*
	st@CɕtV{e[uo^
	xt@C̓ǂݍ݂ɌĂяo
*/
extern void	make_symtable()
{
    char *ptr;		/* V{\ւ̃|C^ */

    ptr = (char*)( Top + Head.text + Head.data + Head.offset );
    while( (ULONG)ptr < (ULONG)( Top + Head.text + Head.data + Head.offset + Head.symbol ) ) {
	symbol	*symbol_ptr;
	int	type;
	address	adrs;
	type = *(UWORD*)ptr;	ptr += sizeof(UWORD);
	adrs = *(address*)ptr;	ptr += sizeof(address);

	if( ( type < 0x201 ) && ( type != 3 ) )
	    add_constsymbol( adrs, ptr );
	else if( ( symbol_ptr = symbol_search( adrs ) ) != NULL )
	    symbol_ptr->type = type;	/* `ς݂Ȃ瑮̏Ĉ */
	else {
	    add_symbol( adrs , type , ptr );
	    regist_label( adrs , DATLABEL | UNKNOWN );
	}
	while( *ptr++ )
	    ;
	ptr += (long)ptr & 1;
    }
}


/*

  n

*/
extern void	free_symbuf()
{
 /* if( Symtable != NULL ) */
	Mfree( Symtable );

 /* if( ConstSymtable != NULL ) */
	Mfree( ConstSymtable );
}


/*

  adrs V{e[u{
  adrs  common text data bss ̂ꂩ
  |C^AłȂ NULL Ԃ

*/
extern symbol	*symbol_search( adrs )
address adrs;
{
    int		step = Symnum >> 1;
    symbol	*ptr = Symtable;

    while( step > 4 ) {
	if( ( ptr + step )->adrs <= adrs )	/* binary search */
	    ptr += step;
	step >>= 1;
    }
    for( ; ptr < Symtable + Symnum ; ptr++ ) {
	if( ptr->adrs == adrs )
	    return ptr;
	else
	    if( adrs < ptr->adrs )
		return NULL;
    }
    return NULL;
}


extern void	add_constsymbol( adrs , symstr )
address adrs;
char	*symstr;
{
    int i;
    i = ConstSymnum;

    ConstSymtable[i].adrs = adrs;
    strncpy( ConstSymtable[i].sym , symstr , 32 );

    if( ++ConstSymnum >= Symbolbufsize )
	err( 1 , "V{e[uӂ܂\n" );
}


extern void	add_symbol( adrs , type , symstr )
address adrs;
int	type;		/* 0 = labelfileł̒` */
char	*symstr;
{
    int  i;

#if 0
    if( type && ( type < 0x201 ) && ( type != 3 ) ) {
	add_constsymbol( adrs, symstr );
	return;
    }
#endif

    if( symbol_search( adrs ) != NULL )
	return;

    for( i = Symnum - 1 ; (i >= 0) && (Symtable[ i ].adrs > adrs) ; i-- )
	Symtable[ i + 1 ] = Symtable[ i ];

#if 0
    if( (i >= 0) && (Symtable[ i ].adrs == adrs) )
	return;
#endif

    i++;
    Symtable[ i ].type = (UWORD)type;
    Symtable[ i ].adrs = adrs;
    strncpy( Symtable[ i ].sym , symstr , 32 );


#ifdef	DEBUG
    printf( "type %4x adrs %6x sym:%s\n" , Symtable[ i ].type ,
	   Symtable[ i ].adrs , Symtable[ i ].sym );
#endif

    if( ++Symnum >= Symbolbufsize )
	err( 1 , "V{e[uӂ܂\n" );
}




extern boolean	is_exist_symbol()
{
    return Symnum ? TRUE : FALSE;
}




extern int  get_constsymbol_num()
{
    return ConstSymnum;
}

extern const_symbol *get_constsymbol( i )
int i;
{
    return ConstSymtable + i;
}

/* EOF */
